Loading...
Searching...
No Matches
consts.h File Reference
Base API

Common constants. More...

`#include <l4/sys/compiler.h>`
`#include <l4/sys/l4int.h>`
Include dependency graph for consts.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | L4_PAGESIZE
| Minimal page size (in bytes).
#define | L4_PAGEMASK
| Mask for the page number.
#define | L4_LOG2_PAGESIZE
| Number of bits used for page offset.
#define | L4_SUPERPAGESIZE
| Size of a large page.
#define | L4_SUPERPAGEMASK
| Mask for the number of a large page.
#define | L4_LOG2_SUPERPAGESIZE
| Number of bits used as offset for a large page.
#define | L4_INVALID_PTR ((void *)L4_INVALID_ADDR)
| Invalid address as pointer type.

## Enumerations

enum | l4_syscall_flags_t { L4_SYSF_NONE , L4_SYSF_SEND , L4_SYSF_RECV , L4_SYSF_OPEN_WAIT , L4_SYSF_REPLY , L4_SYSF_CALL , L4_SYSF_WAIT , L4_SYSF_SEND_AND_WAIT , L4_SYSF_REPLY_AND_WAIT }
| Capability selector flags. More...
enum | l4_cap_consts_t { L4_CAP_SHIFT , L4_CAP_SIZE = 1UL << L4_CAP_SHIFT , L4_CAP_OFFSET , L4_CAP_MASK , L4_INVALID_CAP , L4_INVALID_CAP_BIT = 1UL << (L4_CAP_SHIFT - 1) }
| Constants related to capability selectors. More...
enum | l4_unmap_flags_t { L4_FP_ALL_SPACES , L4_FP_DELETE_OBJ , L4_FP_OTHER_SPACES }
| Flags for the unmap operation. More...
enum | l4_msg_item_consts_t { L4_ITEM_MAP = 8 , L4_ITEM_CONT = 1 , L4_MAP_ITEM_GRANT = 2 , L4_MAP_ITEM_MAP = 0 , L4_RCV_ITEM_FORWARD_MAPPINGS = 1 , L4_RCV_ITEM_SINGLE_CAP = L4_ITEM_MAP | 2 , L4_RCV_ITEM_LOCAL_ID = 4 }
| Constants for message items. More...
enum | l4_buffer_desc_consts_t { L4_BDR_MEM_SHIFT = 0 , L4_BDR_IO_SHIFT = 5 , L4_BDR_OBJ_SHIFT = 10 , L4_BDR_OFFSET_MASK = (1UL << 20) - 1 }
| Constants for buffer descriptors. More...
enum | l4_default_caps_t { L4_BASE_TASK_CAP , L4_BASE_FACTORY_CAP , L4_BASE_THREAD_CAP , L4_BASE_PAGER_CAP , L4_BASE_LOG_CAP , L4_BASE_ICU_CAP , L4_BASE_SCHEDULER_CAP , L4_BASE_IOMMU_CAP , L4_BASE_DEBUGGER_CAP , L4_BASE_ARM_SMCCC_CAP , L4_BASE_CAPS_LAST_P1 , L4_BASE_CAPS_LAST = L4_BASE_CAPS_LAST_P1 - 1 }
| Default capabilities setup for the initial tasks. More...
enum | l4_addr_consts_t { L4_INVALID_ADDR = ~0UL }
| Address related constants. More...

## Functions

l4_addr_t | l4_trunc_page (l4_addr_t address) L4_NOTHROW
| Round an address down to the next lower page boundary.
l4_addr_t | l4_trunc_size (l4_addr_t address, unsigned char bits) L4_NOTHROW
| Round an address down to the next lower flexpage with size bits.
l4_addr_t | l4_round_page (l4_addr_t address) L4_NOTHROW
| Round address up to the next page.
l4_addr_t | l4_round_size (l4_addr_t value, unsigned char bits) L4_NOTHROW
| Round value up to the next alignment with bits size.
unsigned | l4_bytes_to_mwords (unsigned size) L4_NOTHROW
| Determine how many machine words (l4_umword_t) are required to store a buffer of 'size' bytes.

## Detailed Description

Common constants.

Definition in file consts.h.